/*! \file kogmo_rtdb_reader_cxx.cxx
 * \brief Example for reading from the RTDB with the C++ Interface
 *
 * Copyright (c) 2005,2006 Matthias Goebl <mg*tum.de>
 *     Lehrstuhl fuer Realzeit-Computersysteme (RCS)
 *     Technische Universitaet Muenchen (TUM)
 */

#include <iostream>
using namespace std;

#include "kogmo_rtdb.hxx"
using namespace KogniMobil;

int
main (int argc, char **argv)
{
try {

  // Verbindung zur Datenbank aufbauen, unsere Zykluszeit is 33 ms
  RTDBConn DBC("a2_roadtracker_example_cxx", 0.033, "");

  // Auf Object fuer Fahrspur warten
  A2_RoadKloth Road(DBC);
  Road.RTDBSearchWait("a2_eigenfahrspur");

  while (1)
    {
      Road.RTDBReadWaitNext();
      cout << Road;
      cout << "Kruemmung des 1. Segments ist " << Road.getKlothSegC0(1) << endl;
    }
}
catch(DBError err)  
{   
  cout << "Died on Error: " << err.what() << endl;   
  return 1;
}   
};
