# bitte mit ". ./setenv.sh" in der shell einlesen!

# Total amount of Memory dedicated to the Database, including all objects with histories.
# e.g. 64MB for local tests, 500MB on refsys
#export KOGMO_RTDB_HEAPSIZE=14000000 # some default
export KOGMO_RTDB_HEAPSIZE=128000000

# Target database (kogmo_rtdb_man will start under this name, clients using
# libkogmo_rtdb.so will connect to this database.
# If you want, you can connect your clients to someone others database
# by setting KOGMO_RTDB_DBHOST=local:matthias.goebl
export KOGMO_RTDB_DBHOST="local:`id -un`" #your private database
# export KOGMO_RTDB_DBHOST="" # the system database

export KOGMOHOME="`pwd`"

# NOT INSTALLED:
export KOGMO_RTDB_HOME="`pwd`"
export PATH="$KOGMO_RTDB_HOME/rtdb:$KOGMO_RTDB_HOME/gui_c3:$KOGMO_RTDB_HOME/examples:$KOGMO_RTDB_HOME/examples_a2:$KOGMO_RTDB_HOME/can:$PATH"
export LD_LIBRARY_PATH="$KOGMO_RTDB_HOME:$LD_LIBRARY_PATH"
export KOGMO_OBJECTS="`pwd`/objects"

#MAC OS-X:
export DYLD_LIBRARY_PATH="$KOGMO_RTDB_HOME:$DYLD_LIBRARY_PATH"

# INSTALLED:
#export KOGMO_RTDB_HOME="`pwd`/installed/kogmo_rtdb"
#export PATH="$KOGMO_RTDB_HOME/bin:$PATH"
#export LD_LIBRARY_PATH="$KOGMO_RTDB_HOME/lib:$LD_LIBRARY_PATH"
#export KOGMO_OBJECTS="`pwd`/installed/kogmo_objects"

function kogmo_stop () { kogmo_rtdb_man -k;killall -9 kogmo_rtdb_man kogmo_rtdb_dump kogmo_rtdb_test 2>/dev/null ; }
function kogmo_start () { kogmo_rtdb_man && sleep 1 && kogmo_rtdb_dump -m ; }

strace_ipc () {
KOGMO_RTDB_DEBUG=43 strace -f -o /dev/stdout "$@" 2>/dev/null
}
